import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowEvent;
import java.util.StringTokenizer;
import java.util.Stack;
import java.awt.print.*;
import java.awt.event.*;
import java.io.File;


public class Editeur extends JFrame implements ActionListener{
  JToolBar menu=new JToolBar(JToolBar.HORIZONTAL);
  ImageIcon icopier=new ImageIcon(dimensionne_image("editcopy.png",this));
  ImageIcon icoller=new ImageIcon(dimensionne_image("editpaste.png",this));
  ImageIcon icouper=new ImageIcon(dimensionne_image("editcut.png",this));
  ImageIcon iimprimer=new ImageIcon(dimensionne_image("fileprint.png",this));
  ImageIcon iquit=new ImageIcon(dimensionne_image("quit.png",this));
  ImageIcon ilire=new ImageIcon(dimensionne_image("lire.png",this));
  JButton copier=new JButton(icopier);
  JButton coller=new JButton(icoller);
  JButton couper=new JButton(icouper);
  JButton imprimer=new JButton(iimprimer);
  JButton quit=new JButton(iquit);
  JButton lire=new JButton(ilire);

  boolean affichable=true;
  JScrollPane jScrollPane1 = new JScrollPane();
  ZoneEdition zonedition = new ZoneEdition();
  Popup jpop=new Popup(this,zonedition);
  Cadre cadre;
  int curseur=0;
  public Editeur(Cadre cadre){
    this.cadre=cadre;
    this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
    copier.setToolTipText(Logo.messages.getString("copier"));
    couper.setToolTipText(Logo.messages.getString("couper"));
    coller.setToolTipText(Logo.messages.getString("coller"));
    imprimer.setToolTipText(Logo.messages.getString("imprimer_editeur"));
    lire.setToolTipText(Logo.messages.getString("lire_editeur"));
    quit.setToolTipText(Logo.messages.getString("quit_editeur"));

    copier.setActionCommand(Logo.messages.getString("copier"));
    couper.setActionCommand(Logo.messages.getString("couper"));
    coller.setActionCommand(Logo.messages.getString("coller"));
    imprimer.setActionCommand(Logo.messages.getString("imprimer_editeur"));
    lire.setActionCommand(Logo.messages.getString("lire_editeur"));
    quit.setActionCommand(Logo.messages.getString("quit_editeur"));
    lire.setMnemonic('Q');
    quit.setMnemonic('C');

    menu.add(lire);
    menu.addSeparator();
    menu.add(quit);
    menu.addSeparator();
    menu.add(imprimer);
    menu.addSeparator();
    menu.add(copier);
    menu.addSeparator();
    menu.add(couper);
    menu.addSeparator();
    menu.add(coller);

    imprimer.addActionListener(this);
    copier.addActionListener(this);
    couper.addActionListener(this);
    coller.addActionListener(this);
    lire.addActionListener(this);
    quit.addActionListener(this);
	MouseListener popupListener = new PopupListener();
    zonedition.addMouseListener(popupListener);

    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  public Editeur() {
  }
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID()==WindowEvent.WINDOW_CLOSING){
      this.toFront();
    }
    else if (e.getID()==WindowEvent.WINDOW_ACTIVATED){
      zonedition.requestFocus();
    }
  }
  void analyseprocedure()throws EditeurException{ 
//    pile_sauvegarde=new Object[cadre.primitive.procedure.size()];
  //  for(int i=0;i<pile_sauvegarde.length;i++){
    //  pile_sauvegarde[i]=cadre.primitive.procedure.get(i);
    //}
    String commentaire="";
    curseur=0;
    String texte=zonedition.getText();
    int i=0;
    int id=-1;
    String ligne="";
    String mot="";
    StringTokenizer st=new StringTokenizer(ligne);
    Procedure proc=null;

    while(curseur<texte.length()){
      boolean end=false;
      while (!st.hasMoreTokens()&&curseur<texte.length()){
        ligne=ligne(texte);
        st=new StringTokenizer(ligne); //virer les validations inutiles
        if (st.hasMoreTokens()) {mot=st.nextToken();break;}
        else mot="";
      }
      if (mot=="") break;
      if (i==0){          //si c'est la ligne de dfinition
        if (!mot.toLowerCase().equals(Logo.messages.getString("pour"))) throw new EditeurException(this,Logo.messages.getString("erreur_editeur1")+"\n"+Logo.messages.getString("erreur_editeur2")+"\n"+Logo.messages.getString("erreur_editeur3"));
        if (st.hasMoreTokens()) mot=st.nextToken().toLowerCase();
        else throw new EditeurException(this,Logo.messages.getString("erreur_editeur1")+"\n"+Logo.messages.getString("erreur_editeur2")+"\n"+Logo.messages.getString("erreur_editeur3"));
        Stack variable=new Stack();
        id=EstProcedure(mot);
        if (id==-1){      // Si c'est une procdure nouvelle
          String nomproc=mot;
          int nbparam=0;
          while(st.hasMoreTokens()){
            nbparam++;
            mot=st.nextToken().toLowerCase();
            if (mot.substring(0,1).equals(":")&&mot.length()!=1) {
              String var=mot.substring(1,mot.length());
              try{	
              	Double.parseDouble(var);
  				throw new EditeurException(this,Logo.messages.getString("erreur_editeur1")+"\n"+Logo.messages.getString("erreur_editeur2")+"\n"+Logo.messages.getString("erreur_editeur3"));
              }
              catch(NumberFormatException e2){}
              StringTokenizer verif=new StringTokenizer(var, ":+-*/() []=<>&|", true);
              String mess=Logo.messages.getString("caractere_special_variable")+"\n"+Logo.messages.getString("caractere_special2")+"\n"+Logo.messages.getString("caractere_special3")+" :"+var;
              if (verif.countTokens()>1) throw new EditeurException(this,mess);
              if (":+-*/() []=<>&|".indexOf(verif.nextToken())>-1) throw new EditeurException(this,mess);
              if (variable.search(var)==-1) variable.push(var);
            }
            else {throw new EditeurException(this,Logo.messages.getString("erreur_editeur1")+"\n"+Logo.messages.getString("erreur_editeur2")+"\n"+Logo.messages.getString("erreur_editeur3"));}
          }
          cadre.primitive.procedure.push(new Procedure(nomproc,nbparam,variable,cadre.primitive.nbproc,affichable));
          cadre.primitive.nbproc++;
        }
        else {          // Si on redfinit une procdure existante
			    proc=(Procedure)cadre.primitive.procedure.get(id);
          proc.variable.removeAllElements();
          proc.instruction="";
          proc.instr=null;
          int param=0;
					
					while(st.hasMoreTokens()){
            param++;
            mot=st.nextToken().toLowerCase();
            if (mot.substring(0,1).equals(":")&&mot.length()!=1) {
              String var=mot.substring(1,mot.length());
              if (proc.variable.search(var)==-1) proc.variable.push(var);
            }
            else {throw new EditeurException(this,Logo.messages.getString("erreur_editeur1")+"\n"+Logo.messages.getString("erreur_editeur2")+"\n"+Logo.messages.getString("erreur_editeur3"));}
          }
        proc.nbparametre=param;
        cadre.primitive.procedure.set(id,proc);
        }
      }
      else{ //si on est pas  la premire ligne de dfinition.
        if (st.countTokens()!=0||!mot.toLowerCase().equals(Logo.messages.getString("fin"))){
          if (id==-1){      //Procdure nouvelle
            ((Procedure)cadre.primitive.procedure.get(cadre.primitive.nbproc-1)).instruction+=ligne+"\n";
          }
          else{             // Procdure  redfinir
            proc.instruction+=ligne+"\n";
          }
        }
        else end=true;      // Fin de dfinition
      }
      if (end) {
        i=0;
        end=false;
        if (id==-1) commentaire+=((Procedure)cadre.primitive.procedure.peek()).name+", ";
        else {
          commentaire+=((Procedure)cadre.primitive.procedure.get(id)).name+", ";
          cadre.primitive.procedure.set(id,proc);
        }
      }
      else i++;
      while (st.hasMoreTokens()){st.nextToken();} // On vide st
    }
    if (i!=0) {     // On teste si erreur dans l'criture des procdures
      if (id==-1) {
        cadre.primitive.procedure.pop();
        cadre.primitive.nbproc--;
      }
//      else  cadre.primitive.procedure.remove(id);
      
      throw new EditeurException(this,Logo.messages.getString("erreur_editeur1")+"\n"+Logo.messages.getString("erreur_editeur2")+"\n"+Logo.messages.getString("erreur_editeur3"));
    }
//    On cre les chanes d'instruction formates pour chaque procdure et les sauvegardes
    for (int j=0;j<cadre.primitive.procedure.size();j++){
			Procedure pr=((Procedure)cadre.primitive.procedure.get(j));
			pr.decoupe();
			pr.instruction_sauve=pr.instruction;
			pr.instr_sauve=pr.instr;
			pr.variable_sauve=new Stack();
			for (int k=0;k<pr.variable.size();k++){
				pr.variable_sauve.push(pr.variable.get(k));
			}
    }
    if (!commentaire.equals("")&&affichable){
      cadre.panneauHistorique1.ecris("commentaire",Logo.messages.getString("definir")+" "+commentaire.substring(0,commentaire.length()-2)+".\n");
    }
  }
  int EstProcedure(String mot) throws EditeurException{   // vrifie si mot est une procdure
// Vrifier si c'est le nom d'une procdure de dmarrage
    for (int i=0;i<cadre.primitive.procedure.size();i++){
      Procedure procedure=(Procedure)cadre.primitive.procedure.get(i);
      if (procedure.name.equals(mot)&&procedure.affichable==false) throw new EditeurException(this,mot+" "+Logo.messages.getString("existe_deja"));
    }
// Vrifier si ce n'est pas un nombre:
   try{Double.parseDouble(mot);throw new EditeurException(this,Logo.messages.getString("erreur_nom_nombre_procedure"));}
   catch(NumberFormatException e){}
// Vrifier tout d'abord si le mot n'est pas une primitive.
    if (Primitive.primitives.containsKey(mot)) throw new EditeurException(this,mot+" "+Logo.messages.getString("existe_deja"));
    else{
    //ensuite s'il ne contient pas de caractres spciaux "\"
    StringTokenizer decoupe=new StringTokenizer("a"+mot+"a",":\\+-*/() []=<>&|"); //on rajoute une lettre  mot au cas o le caractere spcial se trouve en dbut ou en fin de mot.
    if (decoupe.countTokens()>1) throw new EditeurException(this,Logo.messages.getString("caractere_special1")+"\n"+Logo.messages.getString("caractere_special2")+"\n"+Logo.messages.getString("caractere_special3")+" "+mot);
    }
    for (int i=0;i<cadre.primitive.procedure.size();i++){
      if (((Procedure)cadre.primitive.procedure.get(i)).name.equals(mot)) return(i);
    }
    return(-1);
  }

  static Image dimensionne_image(String nom,Component jf){
	Image image=null;
	image= Toolkit.getDefaultToolkit().getImage(Editeur.class.getResource(nom));
	MediaTracker tracker=new MediaTracker(jf);
	tracker.addImage(image,0);
	try{tracker.waitForID(0);}
	catch(InterruptedException e1){}
	double largeur_ecran=Toolkit.getDefaultToolkit().getScreenSize().getWidth();
	int largeur=image.getWidth(jf); 
	int hauteur=image.getHeight(jf);
	// On fait attention  la rsolution de l'utilisateur
	double facteur = largeur_ecran/1024.0; //les images sont prvues pour 1024x768
	if ((int)(facteur+0.001)!=1){
		image=image.getScaledInstance((int)(facteur*largeur),(int)(facteur*hauteur),Image.SCALE_SMOOTH);
		tracker=new MediaTracker(jf);
		tracker.addImage(image,0);
		try{tracker.waitForID(0);}
		catch(InterruptedException e1){}
	}
	return image;
  }
  String ligne(String texte){       // Extrait la ligne suivante de texte
    String ligne="";
    while(curseur<texte.length()){
      String caractere=texte.substring(curseur,curseur+1);
      curseur++;
      if (caractere.equals("\n")) return ligne;
      else ligne+=caractere;

    }
    return(ligne);
  }
  String mot(String ligne){       // Extrait le mot suivant dans la ligne
    String mot="";
    int i=0;
    while(i<ligne.length()){
      String caractere=ligne.substring(i,i+1);
      if (caractere.equals(" ")) {return mot;}
      else mot+=caractere;
      i++;
    }
    return(mot);
  }
  class EditeurException extends Exception{   //  gnrer en cas d'errreur dans la structure
    EditeurException(){}                      // des pour ... fin
    EditeurException(Editeur editeur,String message){        // et des variables
			JTextArea jt=new JTextArea(message);
			jt.setEditable(false);
			jt.setBackground(new Color(255,255,177));
			jt.setFont(Logo.police);
      JOptionPane.showMessageDialog(editeur,jt,Logo.messages.getString("erreur"),JOptionPane.ERROR_MESSAGE);

			for(int i=0;i<cadre.primitive.procedure.size();i++){ // On remmorise les anciennes dfinitions de procdures
				Procedure pr=(Procedure)cadre.primitive.procedure.get(i);
				pr.variable=(Stack)pr.variable_sauve.clone();
				pr.instr=pr.instr_sauve;
				pr.instruction=pr.instruction_sauve;
				pr.nbparametre=pr.variable.size();
			}
      editeur.toFront();
      editeur.zonedition.requestFocus();
    }
  }
  private void jbInit() throws Exception {
   setIconImage(Toolkit.getDefaultToolkit().createImage(Cadre.class.getResource("icone.png")));
    jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    jScrollPane1.setPreferredSize(new Dimension(500, 500));
    this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    this.setTitle(Logo.messages.getString("editeur"));
    this.getContentPane().add(menu, BorderLayout.NORTH);
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(zonedition, null);
    pack();
  }

  public void actionPerformed(ActionEvent e){
    if (e.getActionCommand().equals(Logo.messages.getString("imprimer_editeur"))){
      Font font=zonedition.getFont();
      String txt=zonedition.getText();
      zonedition.setFont(new Font(font.getFontName(),Font.PLAIN,10));
      zonedition.setText(txt);
      PrinterJob job = PrinterJob.getPrinterJob();
      job.setPrintable(zonedition,job.defaultPage());
      double h_imp=job.defaultPage().getImageableHeight();
       java.awt.FontMetrics fm = zonedition.getFontMetrics(zonedition.getFont());
      zonedition.pages=new Stack();
      StringTokenizer st = new StringTokenizer(txt, "\n");
      String page="";
   //   System.out.println("hauteur "+fm.getHeight()+" "+h_imp);
      int compteur=0;
      while (st.hasMoreTokens()) {
        String element = st.nextToken();
        compteur+=fm.getHeight();
        if (compteur>h_imp) {
          zonedition.pages.push(page);
	      page = element;
          compteur=fm.getHeight();
        }
        else page+= element+"\n";
      }
      if (!page.equals("")) zonedition.pages.push(page);
      if (job.printDialog()) {
        try {
          job.print();
        }
        catch (PrinterException ex) {
          System.out.println(ex.getMessage());
        }
      }
      font=zonedition.getFont();
      zonedition.setFont(new Font(font.getFontName(),Font.PLAIN,12));
      zonedition.setText(txt);
    }
    else if (e.getActionCommand().equals(Logo.messages.getString("copier"))){zonedition.copy();}
    else if (e.getActionCommand().equals(Logo.messages.getString("couper"))){zonedition.cut();}
    else if (e.getActionCommand().equals(Logo.messages.getString("coller"))){zonedition.paste();}
    else if(e.getActionCommand().equals(Logo.messages.getString("lire_editeur"))){
    	this.zonedition.active=false;
    	boolean visible=false;
      try{
      	analyseprocedure();
        this.zonedition.setText("");
				if (null!=cadre.tmp_path){
					Cadre.path=cadre.tmp_path;
					cadre.setTitle("XLOGO        "+Cadre.path);
					try {
						File f=new File(cadre.tmp_path);
						Logo.repertoire_defaut=Logo.rajoute_backslash(f.getParent());
					}
					catch(NullPointerException e2){}
					cadre.tmp_path=null;
					cadre.jMenuFileEnregistrer.setEnabled(true);
				}
				if (!cadre.jMenuFileNouveau.isEnabled()) cadre.jMenuFileNouveau.setEnabled(true); //Si c'est la premire fois qu'on enregistre, on active le menu nouveau
      }
      catch(EditeurException ex){visible=true;}
//			System.out.println(visible);
      setVisible(visible);
      cadre.commande.requestFocus();
      if (Logo.effacer_dessin){ //Effacer la zone de dessin    
      	monException.lance=true;
				cadre.error=true;
				try{while(null!=cadre.affichage&&!cadre.commande.isEditable()) Thread.sleep(100);}
				catch(InterruptedException e1){}
				cadre.primitive.videecran();
				cadre.commande.requestFocus();
      }
    }
		// Si on quitte sans enregistrer
    else if (e.getActionCommand().equals(Logo.messages.getString("quit_editeur"))){
    	this.zonedition.active=false;
      zonedition.setText("");
      setVisible(false);
	  if (Logo.effacer_dessin){ //Effacer la zone de dessin    
		monException.lance=true;
		cadre.error=true;
		try{while(null!=cadre.affichage&&!cadre.commande.isEditable()) Thread.sleep(100);}
		catch(InterruptedException e2){}
		cadre.primitive.videecran();
	  }
		if (null!=cadre.tmp_path) {
			cadre.tmp_path=null;
		} 
      cadre.commande.requestFocus();
    }
  }
	class PopupListener extends MouseAdapter {

		public void mousePressed(MouseEvent e) {
			maybeShowPopup(e);
		}

		public void mouseReleased(MouseEvent e) {
			maybeShowPopup(e);
		}

		private void maybeShowPopup(MouseEvent e) {
			if (e.isPopupTrigger()) {
				jpop.show(e.getComponent(), e.getX(), e.getY());
			}
		}
	}

	
}

/*
    public int print(Graphics g,PageFormat pf, int pi) throws PrinterException{

      int h_imp=(int)pf.getImageableHeight(); //hauteur imprimable sur chaque page
      java.awt.FontMetrics fm = g.getFontMetrics(this.getFont());
      int hauteur_texte=fm.getHeight();
      System.out.println(hauteur_texte);

      if(pi<this.getHeight()/h_imp+1){
        g.translate((int)pf.getImageableX(),(int)pf.getImageableY()-pi*h_imp);
       // System.out.println((int)pf.getImageableY()-pi*h_imp);
        paint(g);
      return(Printable.PAGE_EXISTS);
    }
    else return Printable.NO_SUCH_PAGE;
  }
*/